import cv2
import mediapipe as mp


def findPosition(img, draw=False):
    lmList = []
    if results.multi_hand_landmarks:
        for hand_landmarks in results.multi_hand_landmarks:
            for id, lm in enumerate(hand_landmarks.landmark):
                # print(id, lm)
                h, w, c = image_rgb.shape
                cx, cy = int(lm.x * w), int(lm.y * h)
                lmList.append([id, cx, cy])
                # print(lmList)
                mp_draw.draw_landmarks(image_rgb, hand_landmarks, mp_hands.HAND_CONNECTIONS)
                if draw:
                    cv2.circle(img, (cx, cy), 15, (255, 0, 255), cv2.FILLED)
    return lmList


cap = cv2.VideoCapture(0)
cap.set(3, 640)
cap.set(4, 480)

mp_hands = mp.solutions.hands
hands = mp_hands.Hands()

mp_draw = mp.solutions.drawing_utils
tipIds = [4, 8, 12, 16, 20]
while True:
    success, image = cap.read()
    # print(success)
    image_rgb = cv2.cvtColor(image, cv2.COLOR_BGR2RGB)
    results = hands.process(image_rgb)
    # print(results.multi_hand_landmarks)
    lmList = findPosition(image_rgb)
    if len(lmList) != 0:
        fingers = []
        if lmList[2][1] > lmList[17][1]:
            if (lmList[tipIds[0]][1] > lmList[tipIds[0] - 1][1]):
                fingers.append(1)
            else:
                fingers.append(0)

            for index in range(1, 5):
                if lmList[tipIds[index]][2] < lmList[tipIds[index] - 2][2]:
                    fingers.append(1)
                else:
                    fingers.append(0)
        else:
            if (lmList[tipIds[0]][1] < lmList[tipIds[0] - 1][1]):
                fingers.append(1)
            else:
                fingers.append(0)

            for index in range(1, 5):
                if lmList[tipIds[index]][2] < lmList[tipIds[index] - 2][2]:
                    fingers.append(1)
                else:
                    fingers.append(0)
        print(fingers)

    cv2.imshow('hand tracking', image_rgb)
    cv2.waitKey(1)